
import { zlaqzbmbTableData } from '../data/table/zlaqzbmbData';
import { doubleYBarCharPackage, keyValuePackage, onceYBarChartPackage, rankPackage, tablePackage } from '../dataPackage/inFrontOut';
import { getDoubleYBarChartOut, getKeyValueOut, getOnceYBarChartOut, getTableOut } from '../dataPackage/out';

/*                            质量安全指标面板                    */

export function getData(req, res) {
    let excelData = zlaqzbmbTableData();

    let ret:any = {};

    let dqfxzsPackageData = keyValuePackage(excelData['当前风险指数'].dataList);
    ret['dqfxzs'] = getKeyValueOut('当前风险指数', dqfxzsPackageData);
                    
    let jkPackageData = keyValuePackage(excelData['基坑'].dataList);
    ret['jk'] = getKeyValueOut('基坑', jkPackageData);
                    
    let qjPackageData = keyValuePackage(excelData['区间'].dataList);
    ret['qj'] = getKeyValueOut('区间', qjPackageData);
                    
    let ptdPackageData = keyValuePackage(excelData['旁通道'].dataList);
    ret['ptd'] = getKeyValueOut('旁通道', ptdPackageData);
                    
    let zmxfxfbPackageData = onceYBarChartPackage( excelData['致命性风险分布'], '','');
    ret['zmxfxfb'] = getOnceYBarChartOut('致命性风险分布', zmxfxfbPackageData);
                    
    let gcaqztPackageData = onceYBarChartPackage( excelData['工程安全状态'], '','');
    ret['gcaqzt'] = getOnceYBarChartOut('工程安全状态', gcaqztPackageData);
                     
    res.send(ret);
} 