
import { changeListObjectToListByReflect, changeObjectKey, changeObjectToList, designativListKeyAddUnit, getDesignativByReflect } from "../../dataPackage/interfaceAnalysis";
import { BizError } from "../../util/bizError";
import { getInterfaceByInterfaceName } from "./cronJob";

        
function changeDataProcess(interfaceName, interfaceData, config) {
    let result = {};
    for (let dataName in config) {
        let { type, operationsType, reflect, unitInfo } = config[dataName];
        let fileData = interfaceData[dataName];
        let fileType = typeof fileData;
        let dataIsArray = Array.isArray(fileData);

        if ( (type == "array" && !dataIsArray) || (type == "object" && dataIsArray) || 
            (type == "object" && fileType != "object") || (type != "array" && fileType != type) ) {
            throw new BizError(`接口 ${interfaceName}中的${dataName}类型错误应该为 ${type} 现在为${fileType}`);
        }

        let onceData;
        switch (operationsType) {
            case "object_ToList": onceData= changeObjectToList(fileData, reflect); break;
            case "object_changeKey": onceData = changeObjectKey(fileData, reflect); break;
            case "list_changeKey": onceData = changeListObjectToListByReflect(fileData, reflect); break;
        }

        if (unitInfo) onceData = designativListKeyAddUnit(onceData, unitInfo);

        result[dataName] = onceData;
    }

    return result;
}


function jhjdzbmbInterfaceData() {
    
    let jhjdzbmbinterfaceName = "计划进度指标面板";
    let jhjdzbmbData:any = getInterfaceByInterfaceName(jhjdzbmbinterfaceName);
            
    /*
     jhjd = 计划进度 ;
     zjblxxjd = 证件办理详细进度 ;
     dqxxjd = 动迁详细进度 ;
     yjxxjd = 移交详细进度 ;
     xxjd = 形象进度 ;
     czxxjd = 车站详细进度 ;
     dgjxxjd = 盾构机详细进度 ;
     ptdxxjd = 旁通道详细进度 ;
     lcbjdwcqk = 里程碑节点完成情况 ;
    
    */
    let config = {"jhjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"zjblxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"dqxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"yjxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"xxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"czxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"dgjxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"ptdxxjd":{"type":"object","operationsType":"object_ToList","reflect":"","unitInfo":{}},"lcbjdwcqk":{"type":"array","operationsType":"list_changeKey","reflect":"","unitInfo":{}}};

    let interfaceData = Object.assign({}, jhjdzbmbData );
    let changeData = changeDataProcess('计划进度指标面板', interfaceData, config);
    //todo 剩下的就是将excel定好的数据和interface的数据关联起来了

}
